class Mysql
    class Time
        def initialize(year=0, month=0, day=0, hour=0, minute=0, second=0, neg=false, second_part=0)
            @year, @month, @day, @hour, @minute, @second, @neg, @second_part =
                year.to_i, month.to_i, day.to_i, hour.to_i, minute.to_i, second.to_i, neg, second_part.to_i
        end
        attr_accessor :year, :month, :day, :hour, :minute, :second, :neg, :second_part
        alias mon month
        alias min minute
        alias sec second

        def ==(other)
            other.is_a?(Mysql::Time) &&
                @year == other.year && @month == other.month && @day == other.day &&
                @hour == other.hour && @minute == other.minute && @second == other.second &&
                @neg == neg && @second_part == other.second_part
        end

        def eql?(other)
            self == other
        end

        def to_s
            if year == 0 and mon == 0 and day == 0
                h = neg ? hour * -1 : hour
                sprintf "%02d:%02d:%02d", h, min, sec
            else
                sprintf "%04d-%02d-%02d %02d:%02d:%02d", year, mon, day, hour, min, sec
            end
        end

    end
end
